#include "stm32f1xx_hal.h"
#include "tim.h"
#include "gpio.h"
#include "ds18b20.h"

//*********************************************************************************************
//function                                                                      //
//return    0 -  , 1 -  , 2 - ..                     //
//*********************************************************************************************
uint8_t ds_reset_pulse(void)
{
	if(HAL_GPIO_ReadPin(DS18b20_GPIO_Port, DS18b20_Pin) == GPIO_PIN_RESET)  return 2; //    
	HAL_GPIO_WritePin(DS18b20_GPIO_Port, DS18b20_Pin, GPIO_PIN_RESET); //   
	TIM7->CNT=0;
	while(TIM7->CNT<480){}; // 480 
	HAL_GPIO_WritePin(DS18b20_GPIO_Port, DS18b20_Pin, GPIO_PIN_SET); // 
	while(TIM7->CNT<550){}; // 70 
	if(HAL_GPIO_ReadPin(DS18b20_GPIO_Port, DS18b20_Pin) == GPIO_PIN_SET) return 1; //  
	while(TIM7->CNT<960){}; //  
	return 0; //       
}
//*********************************************************************************************
//function                                                                        //
//argument                                                                   //
//return    none                                                                             //
//*********************************************************************************************
void ds_write_byte(uint8_t byte)
{
	uint8_t i;
  for(i=0;i<8;i++)
	{
		TIM7->CNT=0;
		HAL_GPIO_WritePin(DS18b20_GPIO_Port, DS18b20_Pin, GPIO_PIN_RESET); //   
		while(TIM7->CNT<2){}; // 2 
		if(byte&(1<<i)) HAL_GPIO_WritePin(DS18b20_GPIO_Port, DS18b20_Pin, GPIO_PIN_SET); //  1,   
		while(TIM7->CNT<60){}; // 60  
		HAL_GPIO_WritePin(DS18b20_GPIO_Port, DS18b20_Pin, GPIO_PIN_SET); //  
		while(TIM7->CNT<65){}; // 5   -
	}
}
//*********************************************************************************************
//function                                                                        //
//return                                                                      //
//*********************************************************************************************

uint8_t ds_read_byte(void)
{
	uint8_t i,result = 0;
	for(i=0;i<8;i++)
	{
		TIM7->CNT=0;
		HAL_GPIO_WritePin(DS18b20_GPIO_Port, DS18b20_Pin, GPIO_PIN_RESET); //   
		while(TIM7->CNT<2){}; // 2 
		HAL_GPIO_WritePin(DS18b20_GPIO_Port, DS18b20_Pin, GPIO_PIN_SET); //   
		while(TIM7->CNT<15){}; // 15 
		if(HAL_GPIO_ReadPin(DS18b20_GPIO_Port, DS18b20_Pin) == GPIO_PIN_SET) // 
			result |= 1<<i;
		while(TIM7->CNT<60){}; // 	
	}
	return result;
}
//*********************************************************************************************
//function                                                                   //
//return                                                                //
//*********************************************************************************************
int16_t ds_read_temp(void)
{
	uint16_t result;
	
	result = ds_reset_pulse();
	if(result)
		return result*100;
	else
	{
		ds_write_byte(0xCC); // Cmd Skip ROM
		ds_write_byte(0xBE); // Cmd Read
		result = ds_read_byte(); //  
		result |= (ds_read_byte()<<8); //  
		ds_reset_pulse();
		ds_write_byte(0xCC); // Cmd Skip ROM
		ds_write_byte(0x44); // Cmd Start conversion
		return result;
	}
}

